package net.brokenmoon.afloydwiremod.api;

import net.minecraft.src.NBTTagCompound;

import java.util.ArrayList;
import java.util.Stack;

public class WireConnection {
    public boolean isMade;
    public int x;
    public int y;
    public int z;
    public int thisslot;
    public int thatslot;
    public ArrayList<Integer> xadd = new ArrayList<Integer>();
    public ArrayList<Integer> yadd = new ArrayList<Integer>();
    public ArrayList<Integer> zadd = new ArrayList<Integer>();
    public ArrayList<Integer> sideadd = new ArrayList<Integer>();
    public boolean backwired = false;
    public float red = 1;
    public float green = 0;
    public float blue = 0;
    public float alpha = 1;
    public float width = 0.5f;

    public WireConnection(){
        this.isMade = false;
    }

    public WireConnection(int x, int y, int z, int slot, int slot1, ArrayList<Integer> xadd, ArrayList<Integer> yadd, ArrayList<Integer> zadd, ArrayList<Integer> sideadd, boolean backwired, float red, float green, float blue, float alpha, float width) {
        this.x = x;
        this.y = y;
        this.z = z;
        this.thisslot = slot;
        this.thatslot = slot1;
        this.xadd = xadd;
        this.yadd = yadd;
        this.zadd = zadd;
        this.red = red;
        this.green = green;
        this.blue = blue;
        this.alpha = alpha;
        this.width = width;
        this.sideadd = sideadd;
        this.backwired = backwired;
        this.isMade = true;
    }

    public WireConnection(int xCoord, int yCoord, int zCoord, int slot, int slot1) {
        this.x = xCoord;
        this.y = yCoord;
        this.z = zCoord;
        this.thisslot = slot;
        this.thatslot = slot1;
        this.isMade = true;
    }

    public NBTTagCompound writeToNBT(NBTTagCompound nbttagcompound) {
        nbttagcompound.setInteger("wx", this.x);
        nbttagcompound.setInteger("wy", this.y);
        nbttagcompound.setInteger("wz", this.z);
        nbttagcompound.setBoolean("made", this.isMade);
        nbttagcompound.setInteger("wthisslot", thisslot);
        nbttagcompound.setInteger("wthatslot", thatslot);
        nbttagcompound.setInteger("wexsize", xadd.size());
        nbttagcompound.setBoolean("wback", backwired);
        nbttagcompound.setFloat("wred", red);
        nbttagcompound.setFloat("wgreen", green);
        nbttagcompound.setFloat("wblue", blue);
        nbttagcompound.setFloat("walpha", alpha);
        nbttagcompound.setFloat("wwidth", width);
        for(int i = 0; i < xadd.size(); i++){
            nbttagcompound.setInteger("xadd" + i, xadd.get(i));
            nbttagcompound.setInteger("yadd" + i, yadd.get(i));
            nbttagcompound.setInteger("zadd" + i, zadd.get(i));
            nbttagcompound.setInteger("sideadd" + i, sideadd.get(i));
        }
        return nbttagcompound;
    }

    public void readFromNBT(NBTTagCompound nbttagcompound) {
        this.x = nbttagcompound.getInteger("wx");
        this.y = nbttagcompound.getInteger("wy");
        this.z = nbttagcompound.getInteger("wz");
        this.isMade = nbttagcompound.getBoolean("made");
        this.thisslot = nbttagcompound.getInteger("wthisslot");
        this.thatslot = nbttagcompound.getInteger("wthatslot");
        this.backwired = nbttagcompound.getBoolean("wback");
        this.red = nbttagcompound.getFloat("wred");
        this.green = nbttagcompound.getFloat("wgreen");
        this.blue = nbttagcompound.getFloat("wblue");
        this.alpha = nbttagcompound.getFloat("walpha");
        this.width = nbttagcompound.getFloat("wwidth");
        for(int i = 0; i < nbttagcompound.getInteger("wexsize"); i++){
            this.xadd.add(i, nbttagcompound.getInteger("xadd" + i));
            this.yadd.add(i, nbttagcompound.getInteger("yadd" + i));
            this.zadd.add(i, nbttagcompound.getInteger("zadd" + i));
            this.sideadd.add(i, nbttagcompound.getInteger("sideadd" + i));
        }
    }
}
